#!/usr/bin/env ruby


require 'kconv'
require 'cgi'
require 'uconv'

replace_list = [
  ['chalow', 'http://nais.to/~yto/tools/chalow/'],
  ['Ĥ', 'http://nais.to/~yto/clog/'],
  ['Ȥ桼', 'http://www6.ocn.ne.jp/~katoyuu/'],
  ['椱!', 'http://dayomon.fc2web.com/'],
  ['إåɥ饤', 'http://www014.upp.so-net.ne.jp/wanko/'],
  ['ĤƤ', 'http://blog.zikokeihatu.com/'],
  ['', 'http://dkiroku.com/'],
  ['ɽϿChangeLog', 'http://dkiroku.com/'],
  ['hbtt', 'http://d.hatena.ne.jp/hbtt/'],
  ['satoru-t', 'http://www.namazu.org/~satoru/'],
  ['ů', 'http://www.namazu.org/~satoru/'],
  ['kazuhiko', 'http://kazuhiko.tdiary.net/'],
  ['', 'http://www.ringolab.com/note/daiya/'],
  ['ɴ', 'http://www.100shiki.com/']
]
#-------------------------------------------------------
# ץ饰
#------------------------------------------------------

def asin(isbn, title)
  return "ISBN:#{isbn} #{title}"
end

def shorten_url(url, max=60)
  url.gsub!(/\s+/, '')
  url.gsub!(/\n/, '')
  urlstr = url.gsub(/^(.{#{max}}).+$/, '\1')
  return "[[#{urlstr}|#{url}]]"
end

def google_search(keyword)
	encoding = "ie=EUC-JP&oe=EUC-JP&";
	return "<a href=\"http://www.google.co.jp/search?#{encoding}q=#{URI.escape(keyword)}\">#{keyword}</a>"
end

#--------------------------------
# 
#----------------------------------
data = Kconv.toeuc(ARGF.read())
data.gsub!(/^\t?__DATA__.*$/m, "")

# ȥˤ櫓
linesp = data.split(/(?=^\d{4}-\d{2}-\d{2})/m)
# ꡼ˤ
linesp.each do |x|
  # \r Ϻ
  x.gsub!(/\r/, '')
  # ƬΥ()
  x.gsub!(/^( {8}| {0,7}\t)/, "")
  # ̵̤ʶ
  x.gsub(/^\s+$/, "")
  # 
  x.gsub!(/^(^\d{4}-\d{2}-\d{2})\s\(.+?\)/, '\1')
  # ̩Υȥ
  x.gsub!(/(\* p:.+?)^(\* (?!p:)|\Z)/m, '\2')
  # ȥ
  next if x.gsub!(/^\d{4}-\d\d-\d\d.*?\n+\Z/, "")
  # : ʹߤζ
  x.gsub!(/^(\* .+?:)\s+$/, '\1')
  # Ϣ³Ԥ \n\n ִ
  x.gsub!(/\n\n+/m, "\n\n")
end

# ȥ򥢥ƥˤ櫓
entries = []
linesp.each do |x|
  next if x == ""
  # ȥإåȥƥˤ櫓
  _, entryHeader, items  = *x.match(/\A(\d{4}-\d{2}-\d{2}.+?\n)(.*)\Z/m)
  # ȥإå
  _, year, month, day, user = *entryHeader.to_s.match(/^(\d{4})-(\d{2})-(\d{2})(?:.*?\s\s)(.+)?/)

  # ƥ򥹥ץå
  itemlist = items.split(/^(\* .+?\n(?=\s*(\* |\Z)))/m)

  # ƥϺ
  itemlist.delete_if do |y|
    y =~ /\A(\* |\n|)\z/m
  end

  # ƥϺ
  itemlist.delete_if do |y|
    y =~ /\A(\n)+\z/m
  end

  # message-top ȡmessage-bottom Ϻ
  itemlist.delete_if do |y|
    y =~ /^\* (message-top|message-bottom):(.*)\Z/m
  end
  
  entries.push([year, month, day, itemlist])
end


# hatena style ˤ
entries.each do |x|
  itemlist = x[3]
  itemlist.each_with_index do |y, i|
    # ץ饰
#    y.gsub!(/\{\{(.*?)\}\}/m) do |z|
#      eval $1
#    end

	# ƥ
    y.gsub!(/^\* ([^:]*?)((\[[^\[\]:]+\])+)?:/m) {|x|
	    "*#{$2} #{$1}\n"
    }

    # table
    y.gsub!(/(^(\|\|[^\n]+\n)+)/) {
	    "<table><tr>#{$1.split(/\n/).map{|x| x.split(/\|\|/).join('</td><td>')}.join('<tr>')}</table>"
    }

	# | Ȥ > ǰ
	y.gsub!(/((^((\||>)[^\n]*)\n)+)/) {|m|
		r = $1
		if r =~ /^>>/
			r
		else
			">>\n#{r.gsub(/^(\||>)\s?/m, '')}<<\n"
		end
	}

	# ä <strike>
	y.gsub!(/==(\s.+?)==/) {
		"<strike>#{$1}</strike>"
	}

    # <hr>
    y.gsub!(/^----$/, "<hr>")

    # ISBN: Υ
    y.gsub!(/(?:ASIN|ISBN)(?:_heavy)?:(.{10})/i, "isbn:\\1:detail")

    #  \  URL Ϣ뤹
    urlchars = "[-_.!~*'a-zA-Z0-9;/?:@&=+,%\#\$]"
    urldelim = "\\\\\\n *"
    y.gsub!(Regexp.compile('((?=[^\[\|])(s?https?|ftp)://('+urlchars+'+)('+urldelim+'('+urlchars+'+))*)')) do |z|
      $1.gsub(/\\\n\s*/, '')
    end

    # [src]...[/src]
    y.gsub!(/^\[src\]\n(.*?)^\[\/src\]$/m) {
	    ">||\n#{$1}||<"
    }

    # [esc]...[esc]
    # [literal]...[/literal]
    # [sic]...[/sic]
    y.gsub!(/^\[(?:esc|literal|sic)\]\n(.*?)^\[\/(?:esc|literal|sic)\]$/m) {
	    "\n#{$1.gsub(/\n/, ' ')}"
    }

    # string
	y.gsub!(/'''(.+?)'''/) {
		"<strong>#{$1}</strong>"
	}
	# em
	y.gsub!(/''(.+?)''/) {
		"<em>#{$1}</em>"
	}


    # URL
    y.gsub!(/\[\[(.+?)\s*\|\s*(.+?)\]\]/) {
    	ann = $1
	url = $2
	if ann =~ /\.(jpg|jpeg|png|gif)$/i
		%Q{<a href="#{url}"><img src="#{ann}" alt="img"></a>}
	elsif url =~ /\.(jpg|jpeg|png|gif)$/i
		%Q{<img src="#{url}" alt="#{ann}">}
	else
		%Q{<a href="#{url}">#{ann}</a>}
	end
	}



    itemlist[i] = y
  end
end


puts %Q!<?xml version="1.0" encoding="UTF-8" ?>!
puts '<diary>'

entries.each do |entry|
		  puts %Q!<day date="#{entry[0]}-#{entry[1]}-#{entry[2]}" title="">!
		  puts "  <body>"
		  puts Uconv.euctou8(CGI.escapeHTML(entry[3].to_s))
		  puts "  </body>"
		  puts "</day>"
end
puts "</diary>"

